Imports System
Imports System.IO
Imports System.Net
Imports System.Text

Public Class Form1
    Private Const APP_NAME As String = "howto_net_upload_many_files"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtHost.Text = GetSetting(APP_NAME, "Settings", "Host", "")
        txtDirectory.Text = GetSetting(APP_NAME, "Settings", "Directory", "")
        txtUserName.Text = GetSetting(APP_NAME, "Settings", "UserName", "")
        txtPassword.Text = GetSetting(APP_NAME, "Settings", "Password", "")

        lstFiles.AllowDrop = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SaveSetting(APP_NAME, "Settings", "Host", txtHost.Text)
        SaveSetting(APP_NAME, "Settings", "Directory", txtDirectory.Text)
        SaveSetting(APP_NAME, "Settings", "UserName", txtUserName.Text)
        SaveSetting(APP_NAME, "Settings", "Password", txtPassword.Text)
    End Sub

    Private Sub lstFiles_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFiles.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub lstFiles_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFiles.DragDrop
        For Each filename As String In e.Data.GetData(DataFormats.FileDrop, True)
            If Not lstFiles.Items.Contains(filename) Then
                lstFiles.Items.Add(filename)
            End If
        Next filename
    End Sub

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Static running As Boolean = False
        running = Not running

        If running Then
            Me.Cursor = Cursors.WaitCursor

            ' Build the remote file path as in:
            '   ftp://www.myhost.com/public_html/
            Dim remote_path As String = txtHost.Text
            If Not remote_path.ToLower().StartsWith("ftp://") Then
                remote_path = "ftp://" & remote_path
            End If
            If Not remote_path.EndsWith("/") Then remote_path &= "/"
            remote_path &= txtDirectory.Text
            If Not remote_path.EndsWith("/") Then remote_path &= "/"

            Dim user_name As String = txtUserName.Text
            Dim password As String = txtPassword.Text

            Dim num_copied As Integer = 0

            Do While lstFiles.Items.Count > 0
                Try
                    UploadFile(lstFiles.Items(0), remote_path, user_name, password)
                    lstFiles.Items.RemoveAt(0)
                    num_copied += 1
                Catch ex As Exception
                    MessageBox.Show(ex.Message, "Upload Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Do
                End Try

                Application.DoEvents()
                If Not running Then Exit Do
            Loop
            running = False

            Me.Cursor = Cursors.Default

            MessageBox.Show("Copied " & num_copied & " files", _
                "Done", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    ' Upload the file.
    Private Sub UploadFile(ByVal local_file As String, ByVal remote_path As String, ByVal user_name As String, ByVal password As String)
        ' Get the object used to communicate with the server.
        Dim fi As New FileInfo(local_file)
        Dim remote_file As String = remote_path & fi.Name

        ' Make the WebRequest.
        Dim request As FtpWebRequest = WebRequest.Create(remote_file)
        request.Method = WebRequestMethods.Ftp.UploadFile

        ' Get credentials.
        request.Credentials = New NetworkCredential(user_name, password)

        ' Copy the file into a Byte array.
        Dim source_stream As New StreamReader(local_file)
        Dim file_bytes As Byte() = Encoding.UTF8.GetBytes(source_stream.ReadToEnd())
        source_stream.Close()
        request.ContentLength = file_bytes.Length

        ' Open the request stream and write the bytes into it.
        Dim requestStream As Stream = request.GetRequestStream()
        requestStream.Write(file_bytes, 0, file_bytes.Length)
        requestStream.Close()

        ' Check the response.
        Dim response As FtpWebResponse = request.GetResponse()
        If Not response.StatusDescription.Contains("File successfully transferred") Then
            Dim msg As String = "Error uploading file " & local_file & vbCrLf & response.StatusDescription
            response.Close()
            Throw New Exception(msg)
        End If

        response.Close()
    End Sub
End Class
